package com.SpectacleMng;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.rmi.PortableRemoteObject;
import java.util.*;

public class SeanceClient{

  static public SeanceHome getHome(){

    SeanceHome home  = null;
    Seance seance = null;

    Properties env = new Properties();
    env.setProperty("java.naming.factory.initial",
                    "org.jnp.interfaces.NamingContextFactory");
    env.setProperty("java.naming.provider.url", "localhost:1099");
    env.setProperty("java.naming.factory.url.pkgs", "org.jboss.naming");

    try {
      Context initial = new InitialContext(env);

      Object objref = initial.lookup("ejb/Seance");

      home = (SeanceHome) PortableRemoteObject.narrow(objref,
          SeanceHome.class);
    }
    catch (Exception ex) {
      System.err.println("Could not initialise the entity Bean!");
      ex.printStackTrace();
    }

    return home;

  }

  static public Seance getSeance(SeanceHome home,Integer primaryKey){
    try{
      return home.findByPrimaryKey(primaryKey);
    }catch(Exception e){
      return null;
    }
  }

  static public Collection getAllSeances(SeanceHome home){
    try{
      return home.findByNothing();
    }catch(Exception e){
      return null;
    }
  }


  public static Collection getSeancesBySpectacle(SeanceHome home,String spectacle){
    try {
      return home.findBySpectacle(spectacle);
    }
    catch (Exception e) {
      return null;
    }
  }

  public static Collection getSeancesByTheatre(SeanceHome home,String theatre){
    try {
      return home.findByTheatre(theatre);
    }
    catch (Exception e) {
      return null;
    }
  }

  public static Collection getSeancesBySpectacleAndTheatre(SeanceHome home,String spectacle,String theatre){
    try {
      return home.findBySpectacleAndTheatre(spectacle,theatre);
    }
    catch (Exception e) {
      return null;
    }
  }



  public static Integer getNbSeances(SeanceHome home){
    try {
      return new Integer(home.findByNothing().size());
    }
    catch (Exception e) {
      return new Integer(-1);
    }

  }


  public static void addSeance(SeanceHome home, String date, int placesDispo, String spectacle, String theatre){
    try{
      home.create(getNbSeances(home),date,placesDispo,spectacle,theatre);
    }catch(Exception e){

    }
  }

  public static void main(String[] args) throws Exception{

    SeanceHome home = getHome();
    Seance seance;

    if(args.length > 0 && args[0].equals("insert")){
      System.out.println("Ajout de seance:");

      addSeance(home,"25/03/2005",100,"1-2-3 Sardines","Thtre le Temple");
      addSeance(home,"26/03/2005",100,"1-2-3 Sardines","Thtre le Temple");
      addSeance(home,"27/03/2005",80,"1-2-3 Sardines","Nesle");
      addSeance(home,"28/03/2005",80,"1-2-3 Sardines","Nesle");

      addSeance(home,"25/03/2005",100,"Canard  l'orange","Thtre le Temple");
      addSeance(home,"28/03/2005",100,"Canard  l'orange","Thtre le Temple");
      addSeance(home,"28/03/2005",120,"Canard  l'orange","Comdie Bastille");
      addSeance(home,"30/03/2005",120,"Canard  l'orange","Comdie Bastille");

      addSeance(home,"01/04/2005",120,"Columbo, une femme de trop","Comdie Bastille");
      addSeance(home,"02/04/2005",120,"Columbo, une femme de trop","Comdie Bastille");

    }

    System.out.println("Liste de toutes les seances:");

    Collection listSpetacles = getAllSeances(home);
    Iterator iter = listSpetacles.iterator();
    while( iter.hasNext() ){
      seance = (Seance) iter.next();
      System.out.println(seance.getId());
      System.out.println(seance.getDate());
      System.out.println(seance.getPlacesDispo());
      System.out.println(seance.getSpectacle());
      System.out.println(seance.getTheatre());
    }
  }


}

