package com.SpectacleMng;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.rmi.PortableRemoteObject;
import java.util.*;

public class SpectacleClient{

  static public SpectacleHome getHome(){

    SpectacleHome home  = null;
    Spectacle spectacle = null;

    Properties env = new Properties();
    env.setProperty("java.naming.factory.initial",
                    "org.jnp.interfaces.NamingContextFactory");
    env.setProperty("java.naming.provider.url", "localhost:1099");
    env.setProperty("java.naming.factory.url.pkgs", "org.jboss.naming");

    try {
      Context initial = new InitialContext(env);

      Object objref = initial.lookup("ejb/Spectacle");

      home = (SpectacleHome) PortableRemoteObject.narrow(objref,
          SpectacleHome.class);

    }
    catch (Exception ex) {
      System.err.println("Could not initialise the entity Bean!");
      ex.printStackTrace();
    }

    return home;

  }
  /**
   * Return Object spectacle from EJB using given primary key
   * @return Spectacle
   */
  static public Spectacle getSpectacle(SpectacleHome home,String primaryKey){
    try{
      return home.findByPrimaryKey(primaryKey);
    }catch(Exception e){
      return null;
    }
  }

  static public Collection getSpectacleByDescription(SpectacleHome home,String description){
    try{
      return home.findByDescription(description);
    }catch(Exception e){
      return null;
    }

  }

  static public Collection getAllSpectacles(SpectacleHome home){
    try{
      return home.findByNothing();
    }catch(Exception e){
      return null;
    }

  }

  public static void main(String[] args) throws Exception{

    SpectacleHome home = getHome();

    System.out.println("Attributs d'un Spectacle donn");
    Spectacle spectacle = SpectacleClient.getSpectacle(home,"Canard  l'orange");
    System.out.println(spectacle.getTitre());
    System.out.println(spectacle.getGenre());
    System.out.println(spectacle.getUrl());
    System.out.println(spectacle.getDescription());

    System.out.println("Liste de tous les spectacles:");
    Collection listSpetacles = getAllSpectacles(home);
    Iterator iter = listSpetacles.iterator();
    while( iter.hasNext() ){
      spectacle = (Spectacle) iter.next();
      System.out.println(spectacle.getTitre());
    }





  }
}
