package com.SpectacleWeb;

import com.SpectacleMng.*;
import java.util.*;

public class TheatreServlet {

	String nom   = "";
	String adresse   = "";

	// ----------------------------------------
	// modificateur
	public void setNom(String nom)
	{
		this.nom = nom;
	}

	public void setAdresse(String adresse)
	{
		this.adresse = adresse;
	}



	// ----------------------------------------
	// accesseurs
	public String getNom()
	{
		return nom;
	}

	public String getAdresse()
	{
		return adresse;
	}



	// ----------------------------------------
	// traitement

	/* Retourne tous les theatres
	 *
	 * @return	Collection	ensemble des theatres  retourner
	 */
	public Collection getAllTheatres()
	{
		TheatreHome home = TheatreClient.getHome();
		return TheatreClient.getAllTheatres(home);
	}


	/* Retourne un Theatre en fonction de son nom
	 *
	 * @return	Theatre	Theatre  retourner
	 */
	public Theatre getTheatre()
	{
		TheatreHome home = TheatreClient.getHome();
		return TheatreClient.getTheatre(home, nom);
	}


	/* Retourne les Theatres qui correspondent  certaines contraintes
	 *
	 * @param	String		chaine devant tre contenue dans le titre
	 * @param	String		chaine devant tre contenue dans la description
	 * @param	String		chaine devant tre contenue dans le genre
	 *
	 * @return	Collection	ensemble des Theatres  retourner
	 */
	public Collection getTheatresWhere(String unNom, String uneAdresse) throws Exception
	{
		Collection tousTheatres;
		Vector TheatresRetournes;
		Theatre unTheatre;
		boolean nomConvenable;
		boolean adresseConvenable;

		TheatresRetournes = new Vector();
		TheatreHome home = TheatreClient.getHome();
		tousTheatres = TheatreClient.getAllTheatres(home);

		Iterator iterateur = tousTheatres.iterator();
		while ( iterateur.hasNext() )
		{
			unTheatre = (Theatre) iterateur.next();
			nomConvenable = unTheatre.getNom().toLowerCase().matches("(?i).*" + unNom.toLowerCase() + ".*");
			adresseConvenable = unTheatre.getAdresse().toLowerCase().matches("(?i).*" + uneAdresse.toLowerCase() + ".*");
			
			if ( nomConvenable && adresseConvenable )
			{
				TheatresRetournes.add(unTheatre);
			}
		}
		return TheatresRetournes;
	}
} // Classe AccountBean
