package com.SpectacleMng;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.rmi.PortableRemoteObject;
import java.util.*;

public class AbonneClient{

  static public AbonneHome getHome(){

    AbonneHome home  = null;
    Abonne abonne = null;

    Properties env = new Properties();
    env.setProperty("java.naming.factory.initial",
                    "org.jnp.interfaces.NamingContextFactory");
    env.setProperty("java.naming.provider.url", "localhost:1099");
    env.setProperty("java.naming.factory.url.pkgs", "org.jboss.naming");

    try {
      Context initial = new InitialContext(env);
      Object objref = initial.lookup("ejb/Abonne");
      home = (AbonneHome) PortableRemoteObject.narrow(objref, AbonneHome.class);
    }
    catch (Exception ex) {
      System.err.println("Could not initialise the entity Bean!");
      ex.printStackTrace();
    }

    return home;
  }

  static public Abonne getAbonne(AbonneHome home,String primaryKey){
    try{
      return home.findByPrimaryKey(primaryKey);
    }catch(Exception e){
      return null;
    }
  }

  static public Collection getAbonneByNom(AbonneHome home,String nom){
    try{
      return home.findByNom(nom);
    }catch(Exception e){
      return null;
    }
  }

  static public Collection getAbonneByPrenom(AbonneHome home,String prenom){
    try{
      return home.findByPrenom(prenom);
    }catch(Exception e){
      return null;
    }
  }

  static public Collection getAllAbonnes(AbonneHome home){
    try{
      return home.findByNothing();
    }catch(Exception e){
      return null;
    }
  }

  static public String getNom(AbonneHome home, String mail, String password){
    Abonne abonne;

    try{
      abonne = (Abonne)home.findByMailAndPassword(mail, password).iterator().next();
      if(abonne != null)
        return abonne.getNom();
    }catch(Exception e){
      return null;
    }

    return null;
  }

  static public  Integer getNbAbonnes(AbonneHome home){
    try {
      return new Integer(home.findByNothing().size());
    }
    catch (Exception e) {
      return new Integer(-1);
    }

  }

  static public void addAbonne(AbonneHome home, String email, String nom,
                               String prenom, String password)
  {
    try{
      home.create(email,nom,prenom,password);
    }catch(Exception e){

    }
  }

  static public  void main(String[] args) throws Exception{

    AbonneHome home = getHome();
    Abonne abonne;

   if(args.length > 0 && args[0].equals("insert")){
      System.out.println("Ajout d'abonnes:");

      addAbonne(home,"rabiaza@enst.fr","Anthony","Rabiaza","enst");
      addAbonne(home,"lacot@enst.fr","Xavier","Lacot","enst");
      addAbonne(home,"odurand@enst.fr", "Olivier","Durand","enst");
    }

    System.out.println("Liste de tous les abonnes:");

    Collection listAbonnes = getAllAbonnes(home);
    Iterator iter = listAbonnes.iterator();
    while( iter.hasNext() ){
      abonne = (Abonne) iter.next();
      System.out.println(abonne.getEmail());
      System.out.println(abonne.getNom());
      System.out.println(abonne.getPrenom());
    }
  }


}


