package com.SpectacleMng;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.rmi.PortableRemoteObject;
import java.util.*;
import java.text.*;

public class ReservationClient{

  static public ReservationHome getHome(){

    ReservationHome home  = null;
    Reservation seance = null;

    Properties env = new Properties();
    env.setProperty("java.naming.factory.initial",
                    "org.jnp.interfaces.NamingContextFactory");
    env.setProperty("java.naming.provider.url", "localhost:1099");
    env.setProperty("java.naming.factory.url.pkgs", "org.jboss.naming");

    try {
      Context initial = new InitialContext(env);

      Object objref = initial.lookup("ejb/Reservation");

      home = (ReservationHome) PortableRemoteObject.narrow(objref,
          ReservationHome.class);
    }
    catch (Exception ex) {
      System.err.println("Could not initialise the entity Bean!");
      ex.printStackTrace();
    }

    return home;

  }

  static public Reservation getReservation(ReservationHome home,Integer primaryKey){
    try{
      return home.findByPrimaryKey(primaryKey);
    }catch(Exception e){
      return null;
    }
  }

  static public Collection getReservationsBySeance(ReservationHome home,Integer primaryKey){
    try{
      return home.findBySeance(primaryKey);
    }catch(Exception e){
      return null;
    }
  }
  static public Collection getReservationsByEmail(ReservationHome home,String email){
    try{
      return home.findByAbonne(email);
    }catch(Exception e){
      return null;
    }
  }




  public static Integer getNbReservations(ReservationHome home){
    try {
      return new Integer(home.findByNothing().size());
    }
    catch (Exception e) {
      return new Integer(-1);
    }

  }

  public static void removeReservation(ReservationHome home, Integer id){
    try {
      //recuperation de la reservation  supprimer pour connaitre 
      //son nombre de places
      Reservation a_supprimer = getReservation(home, id);
      int places = a_supprimer.getPlaces();
      Integer seance = a_supprimer.getSeance();
      home.remove(id);

      //augmentation du nombre de places
      SeanceHome seanceHome = SeanceClient.getHome();
      Seance  moving_seance = SeanceClient.getSeance(seanceHome, seance);
      moving_seance.cancelling(places);
    }
    catch (Exception e) {
      e.printStackTrace();
    }

  }

  public static void addReservation(ReservationHome home, int places, int seance, String abonne){
    try{
      if(places<0 || places >10)
        return;
        
      Date today = new Date();
      SimpleDateFormat formatter = new SimpleDateFormat("dd/MM/yy");
      String date = formatter.format(today);

      //ajout de la rservation
      home.create(getNbReservations(home),date,places,new Integer(seance),abonne);

      //dcrmentation du nombre de places
      SeanceHome seanceHome = SeanceClient.getHome();
      Seance  moving_seance = SeanceClient.getSeance(seanceHome,new Integer(seance));
      moving_seance.reservation(places);
      //moving_seance.set
    }catch(Exception e){
    }
  }

  static public Collection getAllReservations(ReservationHome home){
    try{
      return home.findByNothing();
    }catch(Exception e){
      return null;
    }
  }


  public static void main(String[] args) throws Exception{

    ReservationHome home = getHome();
    Reservation seance;

    if(args.length > 0 && args[0].equals("insert")){
      System.out.println("Ajout de reservation:");
      addReservation(home,1,2,"rabiaza@enst.fr");
    }

    System.out.println("Liste de toutes les reservations:");

    Collection listReservations = getAllReservations(home);
    Iterator iter = listReservations.iterator();
    while( iter.hasNext() ){
      seance = (Reservation) iter.next();
      System.out.println(seance.getId());
      System.out.println(seance.getDate());
      System.out.println(seance.getPlaces());
      System.out.println(seance.getAbonne());
      System.out.println(seance.getSeance());
    }

    System.out.println("Suppression de la reservation...");
    removeReservation(home, new Integer(0));

    System.out.println("Liste de toutes les reservations:");

    listReservations = getAllReservations(home);
    iter = listReservations.iterator();
    while (iter.hasNext()) {
      seance = (Reservation) iter.next();
      System.out.println(seance.getId());
      System.out.println(seance.getDate());
      System.out.println(seance.getPlaces());
      System.out.println(seance.getAbonne());
      System.out.println(seance.getSeance());
    }



  }


}


