package com.SpectacleMng;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.rmi.PortableRemoteObject;
import java.util.*;

public class TheatreClient{

  static public TheatreHome getHome(){

    TheatreHome home  = null;
    Theatre theatre = null;

    Properties env = new Properties();
    env.setProperty("java.naming.factory.initial",
                    "org.jnp.interfaces.NamingContextFactory");
    env.setProperty("java.naming.provider.url", "localhost:1099");
    env.setProperty("java.naming.factory.url.pkgs", "org.jboss.naming");

    try {
      Context initial = new InitialContext(env);

      Object objref = initial.lookup("ejb/Theatre");

      home = (TheatreHome) PortableRemoteObject.narrow(objref,
          TheatreHome.class);
    }
    catch (Exception ex) {
      System.err.println("Could not initialise the entity Bean!");
      ex.printStackTrace();
    }

    return home;

  }

  static public Theatre getTheatre(TheatreHome home,String primaryKey){
    try{
      return home.findByPrimaryKey(primaryKey);
    }catch(Exception e){
      return null;
    }
  }

  static public Collection getTheatreByAdress(TheatreHome home,String adress){
    try{
      return home.findByAddress(adress);
    }catch(Exception e){
      return null;
    }
  }

  static public Collection getAllTheatres(TheatreHome home){
    try{
      return home.findByNothing();
    }catch(Exception e){
      return null;
    }
  }


  public static Integer getNbTheatres(TheatreHome home){
    try {
      return new Integer(home.findByNothing().size());
    }
    catch (Exception e) {
      return new Integer(-1);
    }

  }

  static public void addTheatre(TheatreHome home, String nom, String adresse, String infos,
                          String url, int nbSieges){
    try{
      home.create(nom,adresse,infos,url,nbSieges);
    }catch(Exception e){

    }
  }

  public static void main(String[] args) throws Exception{

    TheatreHome home = getHome();
    Theatre theatre;

    System.out.println("Liste de tous les theatres:");

    Collection listSpetacles = getAllTheatres(home);
    Iterator iter = listSpetacles.iterator();
    while( iter.hasNext() ){
      theatre = (Theatre) iter.next();
      System.out.println(theatre.getNom());
      System.out.println(theatre.getInfos());
      System.out.println(theatre.getAdresse());
      System.out.println(theatre.getUrl());
    }
  }


}


